{SSTO constants. Steven S. Pietrobon 21 Dec 1997.
 Revised 2 Aug 1998}
const {ET constants}
  ET_Ms    =   19050; {kg, cutoff mass (engines only)}
  ET_D     =  8.4074; {m,  ET diameter}
  ET_A     =    30.7; {m^2, wings and tail cross-sectional area}

  {MPS constants}
  MPS_N    =       6; {total no. of engines}
  MPS_Tc   =    0.63; {s, engine cutoff time}
  MPS_Ts   =      18; {s, separation time after MECO}
  MPS_R0   =    1.04; {initial thrust ratio}
  MPS_R1   =    0.65; {final thrust ratio}
  MPS_Tt   =      10; {s, MECO throttle down time for 100% thrust change}
  MPS_oh   =    0.01; {propellant overhead in terms of delta V}

  {Spacecraft constants}
  PL_M     =   24000; {kg,  payload mass}
  PL_D     =     4.6; {m,   payload diameter}

  {SSME constants.}
  SSME_Fv  = 2090664; {N,   vacuum thrust}
  SSME_Fs  = 1668083; {N,   sea level thrust}
  SSME_I   =    0.01; {thrust incremental ratio}

  {OMS constants}
  OMS_Mp   =    1000; {kg,  OMS propellant mass}
  OMS_F    =   26689; {N,   vacuum thrust}
  OMS_V    =    3065; {m/s, vacuum exhaust speed}
  OMS_N    =       1; {no. of OMS engines}

  {Propellant exhaust speeds}
  ve0      =    4444; {m/s}
  ve1      =    4365; {m/s}
  ve2      =    4455; {m/s}

  {mixture ratios}
  mr0      =     6.0;
  mr1      =     7.5;
  mr2      =     5.0;

  {Propellant densities}
  dpo      =  1.1490; {kg/l, liquid oxygen}
  dpf      =  0.0709; {kg/l, liquid hydrogen}

  {Launch constants}
  inc      =   51.60; {deg, International Space Station inclination}
  h_turn   =      56; {m,   pitch over altitude}
  angle1   =   -0.03; {deg, pitch over angle rate for stage 1}
  amax1    =   29.42; {m/s^2, maximum acceleration strain}
  via      =  7890.9; {m/s, pre-transfer speed}
  a0       =   11.77; {m/s^2, initial acceleration}
  epsilon  = 0.00001; {a very small non-zero number}
