procedure stage1;
{Finds the trajectory of an SSTO vehicle.
 Steven S. Pietrobon 21 Dec 1997. Revised 2 Aug 1998, 13 Jan 2000}
var Vv,Fv,Vv2,Fv2,dtt,dFt,dRpt,Rd,mp,mf,dv,mf2,mp2,mpo,mpf,mpi:double;
    Vvt,dp0,dp1,dp2,MR,pd,m_i,V_p,V_O,V_F,Id0,Id1,m_t,m_e,m_v,m_c,R_v:double;
    I,J:integer;
    engine:array[1..MPS_N] of integer;

begin{stage 1}
  J := MPS_N div 2;
  for I := 1 to MPS_N do
    if I mod 2 = 1
      then engine[I] := I
      else engine[I] := ((I+J-2) mod (2*J))+1;

  dp0 := (mr0+1)/(mr0/dpo + 1/dpf);
  dp1 := (mr1+1)/(mr1/dpo + 1/dpf);
  dp2 := (mr2+1)/(mr2/dpo + 1/dpf);

  Vv := ve1;
  Id0 := ve0*dp0;
  Id1 := ve1*dp1;
  Fv := SSME_Fv*(Id1/Id0);

  Ar := pi*(sqr(ET_D) + sqr(PL_D))/4 + ET_A;
  Fd := MPS_N*(SSME_Fv-SSME_Fs);
  Me := ET_Ms + PL_M + OMS_Mp;
  t0 := 0.0;
  x0 := 0.0;
  x1s := cos(inc*pi/180)*2*pi*Re/T;
  x1 := x1s;
  h0 := 0.0;
  h1 := 0.0;
  r0 := 0.0;
  p0 := 0.0;
  dRp := 0.0;
  dF := 0.0;
  f0 := MPS_N*Fv*MPS_R0;
  m_i := (f0-Fd)/a0;
  m0 := m_i - Me;
  m1 := -f0/Vv;
  mp := m0;
  mpi := m0;
  write(t0:7:2,gs:6:1,round(x1s):6,round(h0):8,round(r0):10);
  writeln(90.0:7:2,0.0:7:2,90.0:7:2,0.0:9:1,m_i:10:1);

  dt := 1.0;
  dF := 0.0;
  dRp := 0.0;
  dp := 0.0;
  traj := air;
  fair := true;
  hmax := h_turn;
  traj_height;
  dt := 0.1;
  traj_height;
  dt := 0.01;
  traj_height;

  writeln('Pitch over!');
  dp := angle1*pi/180;
  dt := 1.0;
  trajectory;
  dp := 0.0;
  Te := tt;
  time_traj;
  dp := -angle1*pi/180;
  dt := 1.0;
  trajectory;

  writeln('End turn.');
  dp := 0.0;
  Te := (f0/amax1 - m0 - Me)/m1;
  time_traj;
  mpf := (mp-m0)/(mr1+1);
  dv := Vv*ln(1+(mp-m0)/(m0+Me));
  mp := m0;

  write(question,'Maximum angle of attack? ');
  readln(maxa);
  maxa := maxa*pi/180;
  traj := orb;
  iorb := true;
  pow := 2.0;
  Vv2 := ve2;
  Fv2 := SSME_Fv*(ve2*dp2/(ve0*dp0));
  dtt := MPS_Tt*(1.0-Fv2/Fv);
  dFt := MPS_R0*(Fv2 - Fv)/dtt;
  dRpt := MPS_R0*(Fv/Vv - Fv2/Vv2)/dtt;
  for I := 1 to MPS_N do
    begin{change MR}
      writeln('Engine ',engine[I]:1,' MR change!');
      dt := 1.0;
      Te := dtt;
      dF := dFt;
      dRp := dRpt;
      time_traj;
      mpf := mpf + MPS_R0*((MPS_N-I+0.5)*(Fv/Vv)/(mr1+1) + 
                           (I-0.5)*(Fv2/Vv2)/(mr2+1))*Te;
      Vvt := ((MPS_N-I+0.5)*Fv + (I-0.5)*Fv2)/
             ((MPS_N-I+0.5)*Fv/Vv + (I-0.5)*Fv2/Vv2);
      dv := dv + Vvt*ln(1+(mp-m0)/(m0+Me));
      mp := m0;
      dt := 1.0;
      dF := 0.0;
      dRp := 0.0;
      Te := (f0/amax1 - m0 - Me)/m1;
      time_traj;
      mpf := mpf + MPS_R0*((MPS_N-I)*(Fv/Vv)/(mr1+1) + I*(Fv2/Vv2)/(mr2+1))*Te;
      Vvt := ((MPS_N-I)*Fv + I*Fv2)/((MPS_N-I)*Fv/Vv + I*Fv2/Vv2);
      dv := dv + Vvt*ln(1+(mp-m0)/(m0+Me));
      mp := m0;
    end;{change MR}

  Vv := Vv2;
  Fv := Fv2;
  dtt := MPS_Tt*SSME_I;
  dFt := -MPS_N*Fv/MPS_Tt;
  dRpt := -dFt/Vv;
  Rd := MPS_R0;
  repeat
    dt := dtt;
    dF := dFt;
    dRp := dRpt;
    trajectory;
    Rd := Rd - SSME_I;
    dt := 1.0;
    dF := 0.0;
    dRp := 0.0;
    Te := (f0/amax1 - m0 - Me)/m1;
    time_traj;
  until Rd < MPS_R1+epsilon;

  I := 1;
  repeat
    writeln('Engine ',engine[I],' cutoff!');
    dt := MPS_Tc;
    dF := -Fv*MPS_R1/dt;
    dRp := -dF/Vv;
    trajectory;
    Fd := Fd - (SSME_Fv-SSME_Fs);
    dt := 1.0;
    dF := 0.0;
    dRp := 0.0;
    Te := (f0/amax1 - m0 - Me)/m1;
    tt := (exp(m1*(via-vi)/f0)-1)*(m0+Me)/m1;
    if Te < tt 
      then time_traj
      else begin{maxv}
             repeat
               trajectory
             until vi > via;
             dt := -dt;
             trajectory;
             dt := (exp(m1*(via-vi)/f0)-1)*(m0+Me)/m1;
             trajectory;
           end;{maxv}
    I := I+1;
  until (I > MPS_N) or (tt < Te);

  writeln('Main Engine Cutoff (MECO)!');
  write('Perigee = ',(hp/1000):5:1,' km, ');
  write('Apogee = ',(ha/1000):5:1,' km, ');
  writeln('Average Altitude = ',(hp+ha)/2000:5:1,' km');

  mpf := mpf + (mp-m0)/(mr2+1);
  dv := dv + Vv*ln(1+(mp-m0)/(m0+Me));
  mp := mpi - m0;
  mf := ET_Ms + PL_M + OMS_Mp + m0;
  mf2 := mf*exp(-MPS_oh*dv/Vv);
  mp2 := mp + mf - mf2;
  mpf := mpf + (mf-mf2)/(mr2+1);
  mpo := mp2 - mpf;
  MR := mpo/mpf;
  V_O := mpo/dpo;
  V_F := mpf/dpf;
  V_p := V_O + V_F;
  pd := mp2/V_p;
  write('MR = ',MR:3:1,', d_p = ',pd:6:4,' kg/L, ');
  writeln('ve = ',round(ve0):1,' m/s, I_d = ',round(Id0):1,' Ns/L');
  write('Delta V = ',round(dv):1,' m/s, m_i = ',round(m_i):1,' kg, ');
  writeln('V_p = ',round(V_p):1,' L, m_f = ',round(mf2):1,' kg');
  write('m_O = ',round(mpo):1,' kg, m_F = ',round(mpf):1,' kg, ');
  writeln('V_O = ',round(V_O):1,' L, V_F = ',round(V_F):1,' L');
  m_t := 27.0*exp(0.843*ln(1.02*V_O/1000));
  if dpf < 0.2
    then m_t := m_t + 32.3*exp(0.795*ln(1.02*V_F/1000))
    else m_t := m_t + 30.5*exp(0.824*ln(1.02*V_F/1000));
  R_v := SSME_Fv/Id0;
  m_e := MPS_N*R_v*(2.3+2e-7*Id1*R_v);
  m_v := 3.15*(m_t+m_e);
  m_c := mf2-m_v;
  write('m_t = ',round(m_t):1,' kg, m_e = ',round(m_e):1,' kg, ');
  writeln('m_v = ',round(m_v):1,' kg, m_c = ',round(m_c):1,' kg');
end;{stage 1}
